unit MCalculation;

interface

  Function SpaceLess(Str: string): string;
  Function CommaToPoint(Str: string): string;
  Function PointToComma(Str: string): string;
  Function GetExtendedFromString
           (Str: string; NextChar: word): extended;
  Function MyStrToFloat(Str: string): extended;
  Function MyFloatToStr(Str: extended): string;
  Function MyFloatToShotStr(Str: extended): string;

implementation

uses  Math, SysUtils, Dialogs;

Function SpaceLess;
 var i: integer;
begin
   result := '';
   for i:=1 to length(Str) do if Str[i]<>' ' then result := result + Str[i]
end;

Function CommaToPoint;
 var i: integer;
begin
   result := '';
   for i:=1 to length(Str) do if Str[i]<>',' then result := result + Str[i]
                                             else result := result + '.'
end;

Function PointToComma;
 var i: integer;
begin
   result := '';
   for i:=1 to length(Str) do if Str[i]<>'.' then result := result + Str[i]
                                             else result := result + ','
end;

Function GiveMeEtendedFromString(ch: string): extended;
var   i, ii, tempint, tempint2, first,
      second, Pair, OpenPair, CurrentSign: integer;
      tempStr: string;
      CurrPair, op, cl, NofPairFromSing: array [0..600] of integer;
      quantity: array [0..600] of Extended;
      tempResult,tt: extended;

Function GetNumber: Extended;
var TempB: Boolean;
begin
  Result:=0;

  if (ch[currentSign] in ['0'..'9',',']) then
    begin
      TempB:=False;
      if currentSign>1 then
      if (ch[currentSign-1] in ['E','e','','']) and
         (ch[currentSign  ] in ['+','-']) then TempB:=True;
      TempStr:='';
      while (ch[currentSign] in ['0'..'9', ',', 'E','e','',''])or(TempB) do
      begin
        TempStr:=tempStr+ch[currentsign];
        Inc(CurrentSign); if CurrentSign>Length(ch) then break;
        TempB:=False;
        if currentSign>1 then
        if (ch[currentSign-1] in ['E','e','','']) and
           (ch[currentSign  ] in ['+','-']) then TempB:=True;
      end;
     // Canvas.TextOut(10, 30,'getNumber-Result=' + TempStr);
      Result := StrToFloat(TempStr);
    end
  else if ch[currentSign] in ['(','[','{'] then
    begin
      Result:=Quantity[NofPairFromSing[CurrentSign]]; CurrentSign:=cl[NofPairFromSing[CurrentSign]]+1
    end
  else if ch[currentSign]+ch[currentSign+1]='pi' then
    begin
      Result:=pi; CurrentSign:=CurrentSign+2
    end
   else if ch[currentSign]+ch[currentSign+1]+ch[currentSign+2]='exp' then
    begin
      Result:=exp(Quantity[NofPairFromSing[CurrentSign+3]]); currentSign:=cl[NofPairFromSing[CurrentSign+3]]
    end
  else if ch[currentSign]='s' then
    begin
      result:=sin(Quantity[NofPairFromSing[CurrentSign+3]]); currentSign:=cl[NofPairFromSing[CurrentSign-1]]
    end
  else if ch[currentSign]='c' then
    begin
      result:=cos(Quantity[NofPairFromSing[CurrentSign+3]]); currentSign:=cl[NofPairFromSing[CurrentSign-1]]
    end
  else if ch[currentSign]='t' then
    begin
      if cos(Quantity[NofPairFromSing[CurrentSign+3]])<>0 then
      result:=sin(Quantity[NofPairFromSing[CurrentSign+3]])/cos(Quantity[NofPairFromSing[CurrentSign+3]])
      else  begin result:=0; MessageDlg ('   !!! (...tan=sin/cos...)',mtWarning,[mbOK],0)end;
      currentSign:=cl[NofPairFromSing[CurrentSign-1]]
    end
  else if ch[currentSign]='l' then
    begin
      if Quantity[NofPairFromSing[CurrentSign+2]]>0 then
      begin
        if ch[currentSign+1]='n' then result:=ln(Quantity[NofPairFromSing[CurrentSign+2]])
                                 else result:=ln(Quantity[NofPairFromSing[CurrentSign+2]])/ln(10)
      end
      else result:=0;
       currentSign:=cl[NofPairFromSing[CurrentSign-1]]
    end
  {else if ch[currentSign]='x' then
    begin
      Result:=x[strtoint(ch[CurrentSign+1])]; CurrentSign:=CurrentSign+2;
    end    }
  else if ch[currentSign]='a' then
    begin
      if ch[currentSign+3]='t' then begin
      begin
      Result:=ArcTan2(Quantity[NofPairFromSing[CurrentSign+6]],1); CurrentSign:=cl[NofPairFromSing[CurrentSign-1]] end
      end
      else if ch[currentSign+3]='s' then
      begin
        if abs(quantity[NofPairFromSing[CurrentSign+6]])<=1 then
        {result:=0} begin
        Result:=Arcsin(Quantity[NofPairFromSing[CurrentSign+6]]); CurrentSign:=cl[NofPairFromSing[CurrentSign-1]] end
        else
        begin MessageDlg (': sin>1  !? ...arcsin=???',mtWarning,[mbOK],0);result:=0;
        end;
      end
      else if ch[currentSign+3]='c' then
      begin
        if abs(quantity[NofPairFromSing[CurrentSign+6]])<=1 then
        begin
        Result:=Arccos(Quantity[NofPairFromSing[CurrentSign+6]]); CurrentSign:=cl[NofPairFromSing[CurrentSign-1]] end
        else
        begin MessageDlg (': cos>1  !? ...arccos=???',mtWarning,[mbOK],0);result:=0;
        end;
      end;
    end

  else
  BEGIN Result:=0;{MessageDlg (' ...',mtWarning,[mbOK],0) }end;
  GetNumber:=result
end;



begin
      //  .  ...
//     MessageDlg ('CH >'+ch+'<',mtinformation,[mbOK],0);
     ch := '('+ ch +')';
       ii:=0;
      while ii<=length(ch) do
      begin inc(ii);
        if (ch[ii] in ['s','c','t','e']) and (not(ch[ii-1]in['r','o','c'])) then
        begin
          first:=ii; tempint:=ii+3; tempint2:=-1;
          while tempint2<>0 do
          begin
            inc(tempint);if ch[tempint]='(' then dec(tempInt2);if ch[tempint]=')' then inc(tempInt2);
          end;
          second:=tempint+1;
          if not((ch[first-1]='(')and(ch[second]=')')) then
          begin
            setlength(ch,1+length(ch)); for tempint:=length(ch)+1 downto first+1 do ch[tempint]:=ch[tempint-1];
            ch[first]:='(';
            setlength(ch,1+length(ch)); for tempint:=length(ch)+1 downto second+1 do ch[tempint]:=ch[tempint-1];
            ch[second]:=')';
         end; ii:=ii+5;
        end
      end;
      ii:=0;
      while ii<=length(ch) do
      begin inc(ii);
        if (ch[ii]='a') and (ch[ii-1]<>'t') then
        begin
          first:=ii; tempint:=ii+6; tempint2:=-1;
          while tempint2<>0 do
          begin
            inc(tempint);if ch[tempint]='(' then dec(tempInt2);if ch[tempint]=')' then inc(tempInt2);
          end;
          second:=tempint+1;
          if not((ch[first-1]='(')and(ch[second]=')')) then
          begin
            setlength(ch,1+length(ch)); for tempint:=length(ch)+1 downto first+1 do ch[tempint]:=ch[tempint-1];
            ch[first]:='(';
            setlength(ch,1+length(ch)); for tempint:=length(ch)+1 downto second+1 do ch[tempint]:=ch[tempint-1];
            ch[second]:=')';
          end; ii:=ii+8;
        end
      end;
      ii:=0;
      while ii<=length(ch) do
      begin inc(ii);
        if ch[ii]='l' then
        begin
          first:=ii; tempint:=ii+2; tempint2:=-1;
          while tempint2<>0 do
          begin
            inc(tempint);if ch[tempint]='(' then dec(tempInt2);if ch[tempint]=')' then inc(tempInt2);
          end;
          second:=tempint+1;
          if not((ch[first-1]='(')and(ch[second]=')')) then
          begin
              setlength(ch,1+length(ch)); for tempint:=length(ch)+1 downto first+1 do ch[tempint]:=ch[tempint-1];
              ch[first]:='(';
              setlength(ch,1+length(ch)); for tempint:=length(ch)+1 downto second+1 do ch[tempint]:=ch[tempint-1];
              ch[second]:=')';
          end;ii:=ii+5;
        end
      end;

      //MessageDlg (' !',mtinformation,[mbOK],0);

      // ^^^^^^^^^^^^^^^^^^^^^^^^
      ii:=0;
      while ii<=length(ch) do
      begin  inc(ii);
        if ch[ii]='^' then
          begin
            tempint:=ii-1;
            if ch[tempInt] in ['0'..'9',',','x','p','i'] then
            begin
              while ch[tempint] in ['0'..'9',',','x','p','i'] do dec(tempint)
            end
            else if ch[tempInt]=')' then
            begin
              tempInt2:=1; while tempInt2<>0 do
              begin
                dec(tempint);if ch[tempint]='(' then dec(tempInt2) else if ch[tempint]=')' then inc(tempInt2)
              end;
            end; first:=tempint+1;
            tempint:=ii+1;
            if ch[tempInt] in ['0'..'9',',','x','p','i'] then
            begin
              while ch[tempint] in ['0'..'9',',','x','p','i'] do inc(tempint);
              //if ch[tempint]in['('] then dec(tempint);
            end
            else if ch[tempInt]='(' then
            begin
              tempInt2:=-1; inc(tempint);
              while tempint2<>0 do
              begin
                inc(tempint);if ch[tempint]='(' then dec(tempInt2);if ch[tempint]=')' then inc(tempInt2);
              end;
            end;
            second:=tempint+1;
            if not((ch[first-1]='(')and(ch[second-1]=')')) then
            begin
              setlength(ch,1+length(ch)); for tempint:=length(ch)+1 downto first+1 do ch[tempint]:=ch[tempint-1];
              ch[first]:='(';
              setlength(ch,1+length(ch)); for tempint:=length(ch)+1 downto second+1 do ch[tempint]:=ch[tempint-1];
              ch[second]:=')';
            end ;ii:=ii+2;
          end
      end;

      // **********************
      ii:=0;
      while ii<=length(ch) do
        begin  inc(ii);
          if ch[ii] in ['*','/'] then
          begin
            tempint:=ii-1;
            if ch[tempInt] in ['0'..'9',',','x','p','i'] then
            begin
              while ch[tempint] in ['0'..'9',',','x','p','i'] do dec(tempint)
            end
            else if ch[tempInt]=')' then
            begin
              tempInt2:=1; while tempInt2<>0 do
              begin
                dec(tempint);if ch[tempint]='(' then dec(tempInt2) else if ch[tempint]=')' then inc(tempInt2)
              end;
            end
            else if ch[tempInt]='(' then tempint:=ii;  ///???????
            first:=tempint+1;
            tempint:=ii+1;
            if ch[tempInt] in ['0'..'9',',','x','p','i'] then
            begin
              while ch[tempint] in ['0'..'9',',','x','*','/','p','i'] do inc(tempint);
              if ch[tempint]in['(','^'] then dec(tempint);
            end
            else if ch[tempInt]='(' then
            begin
              tempInt2:=-1; inc(tempint);
              while tempint2<>0 do
              begin
                inc(tempint);if ch[tempint]='(' then dec(tempInt2);if ch[tempint]=')' then inc(tempInt2);
              end;
            end
            else if ch[tempInt]=')' then tempint:=ii;
            second:=tempint+1;
        //MessageDlg ('CH >'+ch[first]+ch[second]+'<'+inttostr(second-1),mtinformation,[mbOK],0);
            //if not((ch[first-1]='(')and(ch[second-1]=')')) then
            begin
        // MessageDlg ('>>>>>>>>>>>>>> >'+ch+'<',mtinformation,[mbOK],0);
              setlength(ch,1+length(ch)); for tempint:=length(ch)+1 downto first+1 do ch[tempint]:=ch[tempint-1];
              ch[first]:='(';
              setlength(ch,1+length(ch)); for tempint:=length(ch)+1 downto second+1 do ch[tempint]:=ch[tempint-1];
              ch[second]:=')';
         //MessageDlg ('>>>>>>>>>>>>>> >'+ch+'<',mtinformation,[mbOK],0);
            end;ii:=ii+2;
          end;
        end;
     //MessageDlg ('CH >'+ch+'<',mtinformation,[mbOK],0);

     tempstr:=''; for i:=1 to length(ch) do tempStr:=tempstr+ch[i];
  //MessageDlg ('CH >'+ch+'<',mtinformation,[mbOK],0);
     pair:=0;  OpenPair:=0;
      // ""...  :
     For I:=1 to Length(ch) do
     begin
        if ch[i]='(' then
          begin
            inc(pair); inc(OpenPair); CurrPair[openPair]:=pair;
            op[pair]:=i; NofPairFromSing[i]:=Pair
          end
        else if ch[i]=')' then
          begin
            cl[currPair[openpair]]:=i; Dec(openPair)
          end
     end;
     /////////////////////////////////////////////


        {Functn;FFrom[x1,x2]:=TempResult;}/////////////////////////////<<<<<<<<<<<<<<<<<<<<

//    ***+++///--- :
//FOR tempint:=1 to 1000 do BEGIN
// ListBox1.Items.Clear;//<<<<<<<<<<<<<<<
  tempresult:=5;

  For I:=Pair downto 1 do
  begin
    CurrentSign:=op[i]+1; tempResult:=getNumber;
    while currentSign<>cl[i] do
    begin
      if ch[currentSign]='*' then
        begin inc(currentSign); tempResult:=tempResult*getNumber; end
      else if ch[currentSign]='/' then
        begin inc(currentSign); tt:=getNumber;
      if tt<>0 then tempResult:=tempResult/tt
      else begin tempResult:=0;
           MessageDlg ('   !!!',mtWarning,[mbOK],0) end
      end
      else if ch[currentSign]='+' then
        begin inc(CurrentSign); TempResult:=tempResult+getNumber end
      else if ch[currentSign]='-' then
        begin inc(CurrentSign); TempResult:=tempResult-getNumber end
      else if ch[currentSign]='^' then
        begin inc(CurrentSign);
          if tempResult<>0 then
          tempResult:=exp(getNumber*ln(abs(tempResult)))
          else begin tempResult:=0;//MessageDlg ('lg(0)=???',mtWarning,[mbOK],0)
               end;
               //MessageDlg (' !'+floattostr(currentSign)+'='+floattostr(cl[i]),mtinformation,[mbOK],0);
        end
      else inc(currentSign);
    end;
    tempStr:='';
    Quantity[I]:=TempResult;
  end;
  Result:=tempResult;
   //??>>>>>>>>>     FFrom[x1,x2]:=TempResult;
end;


Function GetExtendedFromString;
var
    i: integer;
    StrPart: string;
begin


  i:=abs(NextChar);  StrPart:='';
  if i <=  length(Str) then
  repeat
     if not(Str[i] in [',', '<']) then StrPart:=StrPart+Str[i]
                                  else Break;
     inc(i);
     if i > length(Str) then Break;
  until 2<1;

  StrPart:= SpaceLess(StrPart);

  if StrPart<>'' then
  begin
    StrPart:=PointToComma(StrPart);
    result:=GiveMeEtendedFromString(StrPart)
  end
  else result:=0;

end;

Function MyStrToFloat;
begin
  Result:=GetExtendedFromString( CommaToPoint(Str), 1 )
end;

Function MyFloatToStr;
begin
  if Str<>0 then
    begin
     if (log10(abs(Str))>-3)and(Abs(str)<10000000) then
       Result:=FormatFloat( '#,###,##0.#########;;0', Str )
     else
       Result:=FormatFloat( '#.###,###,### E-0;;0', Str )
    end
  else
    Result:=FormatFloat( '#.###,###,### E-0;;0', Str )
end;

Function MyFloatToShotStr;
begin
  if Str<>0 then
    begin
     if (log10(abs(Str))>-3)and(Abs(str)<1000) then
       Result:=FormatFloat( '##0.#####;;0', Str )
     else
       Result:=FormatFloat( '0.######E-0;;0', Str )
    end
  else
    Result:=FormatFloat( '0.######E-0;;0', Str )
end;

end.
