unit MathMethod;

interface

uses MMatrix,Mcomplex;

function Seidel(z:TMatrix;x:Tmatrix;n:integer;e:extended;var ki:integer):TMatrix;
{
  -   
  
 z -   
 x -   
 n -  
  
 e -    

   -  
   ki -   
}

function FadeevInvertMatrix(z:TMatrix):TMatrix;
{
        
}

implementation

uses sysutils;

function Seidel(z:TMatrix;x:Tmatrix;n:integer;e:extended;var ki:integer):TMatrix;
var i,j,l,k:integer;
    s:Tcomplex;
begin
result:=TMatrix.Create(1,z.rowcount);
l:=0;
k:=0;
while l=0 do
begin
for i:=1 to z.rowcount do
 begin
 s:=x[1,i];
 for j:=1 to z.rowcount do s:=SubCOmplex(s,MulComplex(z[j,i],result[1,j]));
 s:=divcomplex(s,z[i,i]);
 result[1,i]:=addcomplex(result[1,i],s);
 if e<>0 then if abs(s.r)<e then l:=1;
 end;
inc(k);
if e=0 then if k>=n then l:=1;
end;
ki:=k;
end;

function FadeevInvertMatrix(z:TMatrix):TMatrix;
var p:Tcomplex;
    j,i,x:integer;
    b:Tmatrix;
begin
x:=z.colcount;
if x<>z.rowcount then
  begin
  raise EMathError.create('Fadeev''s Method will Use only to square matrixes.');
  exit;
  end;
result:=TMatrix.Create(x,x);
b:=TMatrix.Create(x,x);
b.copyFromMatrix(z);
p:=z.footstep;
for i:=1 to x do b[i,i]:=SubComplex(b[i,i],p);

for j:=2 to x-1 do
 begin
  b:=MulMatrix(z,b);                //
  p:=DivComplex(b.footstep,MakeComplex(j,0));
  for i:=1 to x do b[i,i]:=SubComplex(b[i,i],p);
end;

result.copyfrommatrix(b);
//for i:=1 to z.Colcount do result[i,i]:=SubComplex(b[i,i],DivComplex(p,MakeComplex(j+1,0)));
b:=MulMatrix(z,Result);
p:=DivComplex(b.footStep,MakeComplex(x,0));

result.DivMatrixPerComplex(p);
end;



end.
